--- old/usr/src/uts/i86pc/os/memnode.c	2015-08-18 18:36:34.681591185 -0400
+++ new/usr/src/uts/i86pc/os/memnode.c	2015-08-18 18:36:34.687066556 -0400
@@ -71,7 +71,6 @@
 mem_node_add_slice(pfn_t start, pfn_t end)
 {
 	int mnode;
-	mnodeset_t newmask, oldmask;
 
 	/*
 	 * DR will pass us the first pfn that is allocatable.
@@ -98,11 +97,7 @@
 		mem_node_config[mnode].physbase = start;
 		mem_node_config[mnode].physmax = end;
 		atomic_inc_16(&num_memnodes);
-		do {
-			oldmask = memnodes_mask;
-			newmask = memnodes_mask | (1ull << mnode);
-		} while (atomic_cas_64(&memnodes_mask, oldmask, newmask) !=
-		    oldmask);
+		atomic_or_64(&memnodes_mask, 1ull << mnode);
 	}
 
 	/*
@@ -123,7 +118,6 @@
 {
 	int mnode;
 	pgcnt_t delta_pgcnt, node_size;
-	mnodeset_t omask, nmask;
 
 	if (mem_node_physalign) {
 		start &= ~(btop(mem_node_physalign) - 1);
@@ -159,10 +153,7 @@
 		 * Delete the whole node.
 		 */
 		ASSERT(MNODE_PGCNT(mnode) == 0);
-		do {
-			omask = memnodes_mask;
-			nmask = omask & ~(1ull << mnode);
-		} while (atomic_cas_64(&memnodes_mask, omask, nmask) != omask);
+		atomic_and_64(&memnodes_mask, ~(1ull << mnode));
 		atomic_dec_16(&num_memnodes);
 		mem_node_config[mnode].exists = 0;
 	}
@@ -223,7 +214,6 @@
 mem_node_alloc()
 {
 	int mnode;
-	mnodeset_t newmask, oldmask;
 
 	/*
 	 * Find an unused memnode.  Update it atomically to prevent
@@ -240,10 +230,7 @@
 	mem_node_config[mnode].physbase = (pfn_t)-1l;
 	mem_node_config[mnode].physmax = 0;
 	atomic_inc_16(&num_memnodes);
-	do {
-		oldmask = memnodes_mask;
-		newmask = memnodes_mask | (1ull << mnode);
-	} while (atomic_cas_64(&memnodes_mask, oldmask, newmask) != oldmask);
+	atomic_or_64(&memnodes_mask, 1ull << mnode);
 
 	return (mnode);
 }
